/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.pua.prot.client.console;

import de.bsvrz.dav.daf.main.ClientDavInterface;
import de.bsvrz.pua.prot.manager.ManagerErrorMessage;
import de.bsvrz.sys.funclib.losb.kernsoftware.ConnectionManager;
import de.bsvrz.sys.funclib.losb.util.cmdinterface.Command;

/**
 * Komando zum Anzeigen aller angemeldeter Sender und Empfänger.
 *
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $Revision$ / $Date$ / ($Author$)
 */
public class ShowSubscriptionsCommand extends Command {

	private ClientDavInterface _dav;

	/**
	 * Ezeugt das Objekt.
	 *
	 * @param dav Verbindung zum Datenverteiler.
	 */
	public ShowSubscriptionsCommand(ClientDavInterface dav) {
		super("Anmeldungen zeigen.", "Zeigt alle von Pua angemeldeten Sender und Empfänger.");
		this._dav = dav;
		if(dav == null) throw new IllegalArgumentException(ManagerErrorMessage.NO_DAV + "Parameter ist null.");
	}

	/** @see de.bsvrz.sys.funclib.losb.util.cmdinterface.Command#execute() */
	@Override
	public void execute() throws Exception {
		this.println("Angemeldete Empfänger:");
		for(String s : ConnectionManager.getReceiverInformation(_dav)) {
			this.println(s);
		}

		this.println("");
		this.println("Angemeldete Sender:");
		for(String s : ConnectionManager.getSenderInformation(_dav)) {
			this.println(s);
		}
	}
}
