/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */

package de.bsvrz.pua.prot.interpreter;

import de.bsvrz.pua.prot.util.ProcessingInformation;
import de.bsvrz.pua.prot.util.ProcessingParameter;
import de.bsvrz.pua.prot.util.ProtocolRequestResult;

import java.io.DataInputStream;


/**
 * Schnittstelle zum Interpreter.
 *
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $Revision$ / $Date$ / ($Author$)
 */
public interface InterpreterInterface {

	/**
	 * Startet die Interpretation des Skripts
	 *
	 * @param script    Quelltext Skript
	 * @param fileName  Dateiname des Skripts (nur für detailliertere Fehlerberichte nötig)
	 * @param parameter Informationen zum Auswerten des Skripts
	 * @param pi        Objekt, in dem die gewonnenen Informationen abgelegt werden
	 *
	 * @return Informationen über die Ausführung der Operation
	 */
	public ProtocolRequestResult process(DataInputStream script, String fileName, ProcessingParameter parameter, ProcessingInformation pi);
}
