// $ANTLR 2.7.7 (2006-11-01): "grammar.g" -> "ProtocolLexer.java"$

/*
 * Copyright 2005-2008 by beck et al. projects GmbH, Munich
 * Copyright 2009 by Kappich Systemberatung, Aachen
 *
 * This file is part of de.bsvrz.pua.prot.
 *
 * de.bsvrz.pua.prot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * de.bsvrz.pua.prot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with de.bsvrz.pua.prot.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * Kappich Systemberatung
 * Martin-Luther-Straße 14
 * 52062 Aachen, Germany
 * phone: +49 241 4090 436
 * mail: <info@kappich.de>
 */
	package de.bsvrz.pua.prot.interpreter;

	import java.io.*;
	import java.awt.event.*;
	import antlr.*;
	import antlr.debug.misc.*;

	import java.util.ArrayList;
	import java.util.HashSet;
	import java.util.List;
	import de.bsvrz.pua.prot.util.ExpressionTree;
	import de.bsvrz.pua.prot.util.ExpressionLeaf;
	import de.bsvrz.pua.prot.exceptions.CriticalParserException;
	import de.bsvrz.pua.prot.exceptions.SemanticErrorException;
	import de.bsvrz.pua.prot.util.ProcessingInformation;
	import de.bsvrz.pua.prot.util.ProcessingParameter;
	import de.bsvrz.sys.funclib.losb.datk.ProtocolType;
	import de.bsvrz.sys.funclib.losb.datk.NoChangeMarker;
	import de.bsvrz.pua.prot.util.attributes.DurationAttributeDescription;

	import de.bsvrz.pua.prot.interpreter.semantics.Semantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AggregationSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AttributeGroupSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.AttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.ExpressionSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.MiscellaneousSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.RealAttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.ScopeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.TempAttributeSemantics;
	import de.bsvrz.pua.prot.interpreter.semantics.SymbolTable;

	import de.bsvrz.dav.daf.main.config.DataModel;


import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.CharScanner;
import antlr.InputBuffer;
import antlr.ByteBuffer;
import antlr.CharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

/**
 * @author Kappich + Kniss Systemberatung Verkehr und Technik
 * @author O. Weiss
 * @author beck et al. projects GmbH
 * @author Martin Hilgers
 * @version $$Revision: 1.9 $$ / $$Date: 2007/12/17 15:22:59 $$ / ($$Author: martinh $$)
 */
public class ProtocolLexer extends antlr.CharScanner implements ProtocolLexerTokenTypes, TokenStream
 {
public ProtocolLexer(InputStream in) {
	this(new ByteBuffer(in));
}
public ProtocolLexer(Reader in) {
	this(new CharBuffer(in));
}
public ProtocolLexer(InputBuffer ib) {
	this(new LexerSharedInputState(ib));
}
public ProtocolLexer(LexerSharedInputState state) {
	super(state);
	caseSensitiveLiterals = true;
	setCaseSensitive(true);
	literals = new Hashtable();
	literals.put(new ANTLRHashString("nicht", this), new Integer(66));
	literals.put(new ANTLRHashString("ereignisprotokoll", this), new Integer(42));
	literals.put(new ANTLRHashString("einschr\u00e4nkung", this), new Integer(22));
	literals.put(new ANTLRHashString("als", this), new Integer(14));
	literals.put(new ANTLRHashString("exp", this), new Integer(71));
	literals.put(new ANTLRHashString("objekt", this), new Integer(27));
	literals.put(new ANTLRHashString("liste", this), new Integer(31));
	literals.put(new ANTLRHashString("mit", this), new Integer(6));
	literals.put(new ANTLRHashString("abs", this), new Integer(75));
	literals.put(new ANTLRHashString("istWahrheitswert", this), new Integer(81));
	literals.put(new ANTLRHashString("nichtauff\u00fcllen", this), new Integer(85));
	literals.put(new ANTLRHashString("istFehler", this), new Integer(76));
	literals.put(new ANTLRHashString("zustandsprotokoll", this), new Integer(41));
	literals.put(new ANTLRHashString("spalte", this), new Integer(28));
	literals.put(new ANTLRHashString("attribut", this), new Integer(12));
	literals.put(new ANTLRHashString("aggregationsfunktion", this), new Integer(51));
	literals.put(new ANTLRHashString("zelle", this), new Integer(47));
	literals.put(new ANTLRHashString("aenderungsprotokoll", this), new Integer(39));
	literals.put(new ANTLRHashString("standards", this), new Integer(33));
	literals.put(new ANTLRHashString("ln", this), new Integer(72));
	literals.put(new ANTLRHashString("unveraendertkennung", this), new Integer(44));
	literals.put(new ANTLRHashString("spalten", this), new Integer(4));
	literals.put(new ANTLRHashString("oder", this), new Integer(53));
	literals.put(new ANTLRHashString("definitionen", this), new Integer(50));
	literals.put(new ANTLRHashString("modulo", this), new Integer(65));
	literals.put(new ANTLRHashString("falsch", this), new Integer(82));
	literals.put(new ANTLRHashString("nichtauffuellen", this), new Integer(84));
	literals.put(new ANTLRHashString("unver\u00e4ndertkennung", this), new Integer(48));
	literals.put(new ANTLRHashString("potenz", this), new Integer(70));
	literals.put(new ANTLRHashString("verschmelzen", this), new Integer(23));
	literals.put(new ANTLRHashString("attributgruppe", this), new Integer(17));
	literals.put(new ANTLRHashString("pseudoobjekt", this), new Integer(49));
	literals.put(new ANTLRHashString("gesamt", this), new Integer(25));
	literals.put(new ANTLRHashString("pro", this), new Integer(45));
	literals.put(new ANTLRHashString("und", this), new Integer(54));
	literals.put(new ANTLRHashString("min", this), new Integer(73));
	literals.put(new ANTLRHashString("istText", this), new Integer(80));
	literals.put(new ANTLRHashString("protokollzeitraum", this), new Integer(34));
	literals.put(new ANTLRHashString("zeitdauer", this), new Integer(13));
	literals.put(new ANTLRHashString("istLeer", this), new Integer(79));
	literals.put(new ANTLRHashString("zeile", this), new Integer(46));
	literals.put(new ANTLRHashString("anwendung", this), new Integer(24));
	literals.put(new ANTLRHashString("alias", this), new Integer(52));
	literals.put(new ANTLRHashString("aggregation", this), new Integer(19));
	literals.put(new ANTLRHashString("\u00e4nderungsprotokoll", this), new Integer(40));
	literals.put(new ANTLRHashString("protokollart", this), new Integer(38));
	literals.put(new ANTLRHashString("intervall", this), new Integer(30));
	literals.put(new ANTLRHashString("istZahl", this), new Integer(77));
	literals.put(new ANTLRHashString("max", this), new Integer(74));
	literals.put(new ANTLRHashString("nachfilter", this), new Integer(32));
	literals.put(new ANTLRHashString("filter", this), new Integer(18));
	literals.put(new ANTLRHashString("einschraenkung", this), new Integer(21));
	literals.put(new ANTLRHashString("istZustand", this), new Integer(78));
	literals.put(new ANTLRHashString("ende", this), new Integer(7));
	literals.put(new ANTLRHashString("tempAttribut", this), new Integer(16));
	literals.put(new ANTLRHashString("div", this), new Integer(64));
	literals.put(new ANTLRHashString("wahr", this), new Integer(83));
}

public Token nextToken() throws TokenStreamException {
	Token theRetToken=null;
tryAgain:
	for (;;) {
		Token _token = null;
		int _ttype = Token.INVALID_TYPE;
		resetText();
		try {   // for char stream error handling
			try {   // for lexical error handling
				switch ( LA(1)) {
				case '&':
				{
					mAmpersand(true);
					theRetToken=_returnToken;
					break;
				}
				case '/':
				{
					mDividiert(true);
					theRetToken=_returnToken;
					break;
				}
				case ':':
				{
					mDoppelpunkt(true);
					theRetToken=_returnToken;
					break;
				}
				case '[':
				{
					mEckigeKlammerAuf(true);
					theRetToken=_returnToken;
					break;
				}
				case ']':
				{
					mEckigeKlammerZu(true);
					theRetToken=_returnToken;
					break;
				}
				case '?':
				{
					mFragezeichen(true);
					theRetToken=_returnToken;
					break;
				}
				case '=':
				{
					mGleich(true);
					theRetToken=_returnToken;
					break;
				}
				case '(':
				{
					mKlammerAuf(true);
					theRetToken=_returnToken;
					break;
				}
				case ')':
				{
					mKlammerZu(true);
					theRetToken=_returnToken;
					break;
				}
				case ',':
				{
					mKomma(true);
					theRetToken=_returnToken;
					break;
				}
				case '*':
				{
					mMal(true);
					theRetToken=_returnToken;
					break;
				}
				case '-':
				{
					mMinus(true);
					theRetToken=_returnToken;
					break;
				}
				case '+':
				{
					mPlus(true);
					theRetToken=_returnToken;
					break;
				}
				case '%':
				{
					mProzent(true);
					theRetToken=_returnToken;
					break;
				}
				case '.':
				{
					mPunkt(true);
					theRetToken=_returnToken;
					break;
				}
				case 'A':  case 'B':  case 'C':  case 'D':
				case 'E':  case 'F':  case 'G':  case 'H':
				case 'I':  case 'J':  case 'K':  case 'L':
				case 'M':  case 'N':  case 'O':  case 'P':
				case 'Q':  case 'R':  case 'S':  case 'T':
				case 'U':  case 'V':  case 'W':  case 'X':
				case 'Y':  case 'Z':  case '_':  case 'a':
				case 'b':  case 'c':  case 'd':  case 'e':
				case 'f':  case 'g':  case 'h':  case 'i':
				case 'j':  case 'k':  case 'l':  case 'm':
				case 'n':  case 'o':  case 'p':  case 'q':
				case 'r':  case 's':  case 't':  case 'u':
				case 'v':  case 'w':  case 'x':  case 'y':
				case 'z':  case '\u00c4':  case '\u00d6':  case '\u00dc':
				case '\u00df':  case '\u00e4':  case '\u00f6':  case '\u00fc':
				{
					mNameOderNameMitKlammern(true);
					theRetToken=_returnToken;
					break;
				}
				case '#':
				{
					mSL_COMMENT(true);
					theRetToken=_returnToken;
					break;
				}
				case '0':  case '1':  case '2':  case '3':
				case '4':  case '5':  case '6':  case '7':
				case '8':  case '9':
				{
					mDatumOderZahl(true);
					theRetToken=_returnToken;
					break;
				}
				case '"':
				{
					mZeichenkette(true);
					theRetToken=_returnToken;
					break;
				}
				case '\t':  case ' ':  case '\\':
				{
					mWS(true);
					theRetToken=_returnToken;
					break;
				}
				case '\n':  case '\r':
				{
					mZeilenEnde(true);
					theRetToken=_returnToken;
					break;
				}
				default:
					if ((LA(1)=='>') && (LA(2)=='=')) {
						mGroesserGleich(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (LA(2)=='=')) {
						mKleinerGleich(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (LA(2)=='>')) {
						mUngleich(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='>') && (true)) {
						mGroesser(true);
						theRetToken=_returnToken;
					}
					else if ((LA(1)=='<') && (true)) {
						mKleiner(true);
						theRetToken=_returnToken;
					}
				else {
					if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
				else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				}
				if ( _returnToken==null ) continue tryAgain; // found SKIP token
				_ttype = _returnToken.getType();
				_ttype = testLiteralsTable(_ttype);
				_returnToken.setType(_ttype);
				return _returnToken;
			}
			catch (RecognitionException e) {
				throw new TokenStreamRecognitionException(e);
			}
		}
		catch (CharStreamException cse) {
			if ( cse instanceof CharStreamIOException ) {
				throw new TokenStreamIOException(((CharStreamIOException)cse).io);
			}
			else {
				throw new TokenStreamException(cse.getMessage());
			}
		}
	}
}

	public final void mAmpersand(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Ampersand;
		int _saveIndex;
		
		match('&');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mDividiert(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Dividiert;
		int _saveIndex;
		
		match('/');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mDoppelpunkt(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Doppelpunkt;
		int _saveIndex;
		
		match(':');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mEckigeKlammerAuf(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = EckigeKlammerAuf;
		int _saveIndex;
		
		match('[');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mEckigeKlammerZu(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = EckigeKlammerZu;
		int _saveIndex;
		
		match(']');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mFragezeichen(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Fragezeichen;
		int _saveIndex;
		
		match('?');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mGleich(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Gleich;
		int _saveIndex;
		
		match('=');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mGroesser(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Groesser;
		int _saveIndex;
		
		match('>');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mGroesserGleich(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = GroesserGleich;
		int _saveIndex;
		
		mGroesser(false);
		mGleich(false);
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mKlammerAuf(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KlammerAuf;
		int _saveIndex;
		
		match('(');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mKlammerZu(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KlammerZu;
		int _saveIndex;
		
		match(')');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mKleiner(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Kleiner;
		int _saveIndex;
		
		match('<');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mKleinerGleich(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KleinerGleich;
		int _saveIndex;
		
		mKleiner(false);
		mGleich(false);
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mKomma(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Komma;
		int _saveIndex;
		
		match(',');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mMal(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Mal;
		int _saveIndex;
		
		match('*');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mMinus(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Minus;
		int _saveIndex;
		
		match('-');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mPlus(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Plus;
		int _saveIndex;
		
		match('+');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mProzent(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Prozent;
		int _saveIndex;
		
		match('%');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mPunkt(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Punkt;
		int _saveIndex;
		
		match('.');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mUngleich(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Ungleich;
		int _saveIndex;
		
		mKleiner(false);
		mGroesser(false);
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mNameOderNameMitKlammern(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NameOderNameMitKlammern;
		int _saveIndex;
		
		boolean synPredMatched159 = false;
		if (((_tokenSet_0.member(LA(1))) && (true) && (true) && (true) && (true) && (true))) {
			int _m159 = mark();
			synPredMatched159 = true;
			inputState.guessing++;
			try {
				{
				{
				switch ( LA(1)) {
				case 'a':  case 'b':  case 'c':  case 'd':
				case 'e':  case 'f':  case 'g':  case 'h':
				case 'i':  case 'j':  case 'k':  case 'l':
				case 'm':  case 'n':  case 'o':  case 'p':
				case 'q':  case 'r':  case 's':  case 't':
				case 'u':  case 'v':  case 'w':  case 'x':
				case 'y':  case 'z':
				{
					matchRange('a','z');
					break;
				}
				case 'A':  case 'B':  case 'C':  case 'D':
				case 'E':  case 'F':  case 'G':  case 'H':
				case 'I':  case 'J':  case 'K':  case 'L':
				case 'M':  case 'N':  case 'O':  case 'P':
				case 'Q':  case 'R':  case 'S':  case 'T':
				case 'U':  case 'V':  case 'W':  case 'X':
				case 'Y':  case 'Z':
				{
					matchRange('A','Z');
					break;
				}
				case '_':
				{
					match('_');
					break;
				}
				case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
				case '\u00e4':  case '\u00f6':  case '\u00fc':
				{
					mUmlaut(false);
					break;
				}
				default:
				{
					throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				{
				_loop155:
				do {
					switch ( LA(1)) {
					case 'a':  case 'b':  case 'c':  case 'd':
					case 'e':  case 'f':  case 'g':  case 'h':
					case 'i':  case 'j':  case 'k':  case 'l':
					case 'm':  case 'n':  case 'o':  case 'p':
					case 'q':  case 'r':  case 's':  case 't':
					case 'u':  case 'v':  case 'w':  case 'x':
					case 'y':  case 'z':
					{
						matchRange('a','z');
						break;
					}
					case 'A':  case 'B':  case 'C':  case 'D':
					case 'E':  case 'F':  case 'G':  case 'H':
					case 'I':  case 'J':  case 'K':  case 'L':
					case 'M':  case 'N':  case 'O':  case 'P':
					case 'Q':  case 'R':  case 'S':  case 'T':
					case 'U':  case 'V':  case 'W':  case 'X':
					case 'Y':  case 'Z':
					{
						matchRange('A','Z');
						break;
					}
					case '_':
					{
						match('_');
						break;
					}
					case '.':
					{
						match('.');
						break;
					}
					case '-':
					{
						match('-');
						break;
					}
					case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
					case '\u00e4':  case '\u00f6':  case '\u00fc':
					{
						mUmlaut(false);
						break;
					}
					case '0':  case '1':  case '2':  case '3':
					case '4':  case '5':  case '6':  case '7':
					case '8':  case '9':
					{
						matchRange('0','9');
						break;
					}
					default:
					{
						break _loop155;
					}
					}
				} while (true);
				}
				{
				switch ( LA(1)) {
				case '[':
				{
					match('[');
					break;
				}
				case ']':
				{
					match(']');
					break;
				}
				default:
				{
					throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				{
				_loop158:
				do {
					switch ( LA(1)) {
					case 'a':  case 'b':  case 'c':  case 'd':
					case 'e':  case 'f':  case 'g':  case 'h':
					case 'i':  case 'j':  case 'k':  case 'l':
					case 'm':  case 'n':  case 'o':  case 'p':
					case 'q':  case 'r':  case 's':  case 't':
					case 'u':  case 'v':  case 'w':  case 'x':
					case 'y':  case 'z':
					{
						matchRange('a','z');
						break;
					}
					case 'A':  case 'B':  case 'C':  case 'D':
					case 'E':  case 'F':  case 'G':  case 'H':
					case 'I':  case 'J':  case 'K':  case 'L':
					case 'M':  case 'N':  case 'O':  case 'P':
					case 'Q':  case 'R':  case 'S':  case 'T':
					case 'U':  case 'V':  case 'W':  case 'X':
					case 'Y':  case 'Z':
					{
						matchRange('A','Z');
						break;
					}
					case '_':
					{
						match('_');
						break;
					}
					case '.':
					{
						match('.');
						break;
					}
					case '-':
					{
						match('-');
						break;
					}
					case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
					case '\u00e4':  case '\u00f6':  case '\u00fc':
					{
						mUmlaut(false);
						break;
					}
					case '0':  case '1':  case '2':  case '3':
					case '4':  case '5':  case '6':  case '7':
					case '8':  case '9':
					{
						matchRange('0','9');
						break;
					}
					case '[':
					{
						match('[');
						break;
					}
					case ']':
					{
						match(']');
						break;
					}
					default:
					{
						break _loop158;
					}
					}
				} while (true);
				}
				}
			}
			catch (RecognitionException pe) {
				synPredMatched159 = false;
			}
			rewind(_m159);
inputState.guessing--;
		}
		if ( synPredMatched159 ) {
			mNameMitKlammern(false);
			if ( inputState.guessing==0 ) {
				_ttype = NameMitKlammern;
			}
		}
		else {
			boolean synPredMatched164 = false;
			if (((_tokenSet_0.member(LA(1))) && (true) && (true) && (true) && (true) && (true))) {
				int _m164 = mark();
				synPredMatched164 = true;
				inputState.guessing++;
				try {
					{
					{
					switch ( LA(1)) {
					case 'a':  case 'b':  case 'c':  case 'd':
					case 'e':  case 'f':  case 'g':  case 'h':
					case 'i':  case 'j':  case 'k':  case 'l':
					case 'm':  case 'n':  case 'o':  case 'p':
					case 'q':  case 'r':  case 's':  case 't':
					case 'u':  case 'v':  case 'w':  case 'x':
					case 'y':  case 'z':
					{
						matchRange('a','z');
						break;
					}
					case 'A':  case 'B':  case 'C':  case 'D':
					case 'E':  case 'F':  case 'G':  case 'H':
					case 'I':  case 'J':  case 'K':  case 'L':
					case 'M':  case 'N':  case 'O':  case 'P':
					case 'Q':  case 'R':  case 'S':  case 'T':
					case 'U':  case 'V':  case 'W':  case 'X':
					case 'Y':  case 'Z':
					{
						matchRange('A','Z');
						break;
					}
					case '_':
					{
						match('_');
						break;
					}
					case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
					case '\u00e4':  case '\u00f6':  case '\u00fc':
					{
						mUmlaut(false);
						break;
					}
					default:
					{
						throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
					}
					}
					}
					{
					_loop163:
					do {
						switch ( LA(1)) {
						case 'a':  case 'b':  case 'c':  case 'd':
						case 'e':  case 'f':  case 'g':  case 'h':
						case 'i':  case 'j':  case 'k':  case 'l':
						case 'm':  case 'n':  case 'o':  case 'p':
						case 'q':  case 'r':  case 's':  case 't':
						case 'u':  case 'v':  case 'w':  case 'x':
						case 'y':  case 'z':
						{
							matchRange('a','z');
							break;
						}
						case 'A':  case 'B':  case 'C':  case 'D':
						case 'E':  case 'F':  case 'G':  case 'H':
						case 'I':  case 'J':  case 'K':  case 'L':
						case 'M':  case 'N':  case 'O':  case 'P':
						case 'Q':  case 'R':  case 'S':  case 'T':
						case 'U':  case 'V':  case 'W':  case 'X':
						case 'Y':  case 'Z':
						{
							matchRange('A','Z');
							break;
						}
						case '_':
						{
							match('_');
							break;
						}
						case '.':
						{
							match('.');
							break;
						}
						case '-':
						{
							match('-');
							break;
						}
						case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
						case '\u00e4':  case '\u00f6':  case '\u00fc':
						{
							mUmlaut(false);
							break;
						}
						case '0':  case '1':  case '2':  case '3':
						case '4':  case '5':  case '6':  case '7':
						case '8':  case '9':
						{
							matchRange('0','9');
							break;
						}
						default:
						{
							break _loop163;
						}
						}
					} while (true);
					}
					}
				}
				catch (RecognitionException pe) {
					synPredMatched164 = false;
				}
				rewind(_m164);
inputState.guessing--;
			}
			if ( synPredMatched164 ) {
				mName(false);
				if ( inputState.guessing==0 ) {
					_ttype = Name;
				}
			}
			else {
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
				_token = makeToken(_ttype);
				_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
			}
			_returnToken = _token;
		}
		
	protected final void mUmlaut(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Umlaut;
		int _saveIndex;
		
		switch ( LA(1)) {
		case '\u00e4':
		{
			match('\u00e4');
			break;
		}
		case '\u00c4':
		{
			match('\u00c4');
			break;
		}
		case '\u00f6':
		{
			match('\u00f6');
			break;
		}
		case '\u00d6':
		{
			match('\u00d6');
			break;
		}
		case '\u00fc':
		{
			match('\u00fc');
			break;
		}
		case '\u00dc':
		{
			match('\u00dc');
			break;
		}
		case '\u00df':
		{
			match('\u00df');
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mNameMitKlammern(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = NameMitKlammern;
		int _saveIndex;
		
		{
		switch ( LA(1)) {
		case 'a':  case 'b':  case 'c':  case 'd':
		case 'e':  case 'f':  case 'g':  case 'h':
		case 'i':  case 'j':  case 'k':  case 'l':
		case 'm':  case 'n':  case 'o':  case 'p':
		case 'q':  case 'r':  case 's':  case 't':
		case 'u':  case 'v':  case 'w':  case 'x':
		case 'y':  case 'z':
		{
			matchRange('a','z');
			break;
		}
		case 'A':  case 'B':  case 'C':  case 'D':
		case 'E':  case 'F':  case 'G':  case 'H':
		case 'I':  case 'J':  case 'K':  case 'L':
		case 'M':  case 'N':  case 'O':  case 'P':
		case 'Q':  case 'R':  case 'S':  case 'T':
		case 'U':  case 'V':  case 'W':  case 'X':
		case 'Y':  case 'Z':
		{
			matchRange('A','Z');
			break;
		}
		case '_':
		{
			match('_');
			break;
		}
		case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
		case '\u00e4':  case '\u00f6':  case '\u00fc':
		{
			mUmlaut(false);
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		{
		_loop172:
		do {
			switch ( LA(1)) {
			case 'a':  case 'b':  case 'c':  case 'd':
			case 'e':  case 'f':  case 'g':  case 'h':
			case 'i':  case 'j':  case 'k':  case 'l':
			case 'm':  case 'n':  case 'o':  case 'p':
			case 'q':  case 'r':  case 's':  case 't':
			case 'u':  case 'v':  case 'w':  case 'x':
			case 'y':  case 'z':
			{
				matchRange('a','z');
				break;
			}
			case 'A':  case 'B':  case 'C':  case 'D':
			case 'E':  case 'F':  case 'G':  case 'H':
			case 'I':  case 'J':  case 'K':  case 'L':
			case 'M':  case 'N':  case 'O':  case 'P':
			case 'Q':  case 'R':  case 'S':  case 'T':
			case 'U':  case 'V':  case 'W':  case 'X':
			case 'Y':  case 'Z':
			{
				matchRange('A','Z');
				break;
			}
			case '_':
			{
				match('_');
				break;
			}
			case '.':
			{
				match('.');
				break;
			}
			case '-':
			{
				match('-');
				break;
			}
			case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
			case '\u00e4':  case '\u00f6':  case '\u00fc':
			{
				mUmlaut(false);
				break;
			}
			case '0':  case '1':  case '2':  case '3':
			case '4':  case '5':  case '6':  case '7':
			case '8':  case '9':
			{
				matchRange('0','9');
				break;
			}
			case '[':
			{
				match('[');
				break;
			}
			case ']':
			{
				match(']');
				break;
			}
			default:
			{
				break _loop172;
			}
			}
		} while (true);
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mName(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Name;
		int _saveIndex;
		
		{
		switch ( LA(1)) {
		case 'a':  case 'b':  case 'c':  case 'd':
		case 'e':  case 'f':  case 'g':  case 'h':
		case 'i':  case 'j':  case 'k':  case 'l':
		case 'm':  case 'n':  case 'o':  case 'p':
		case 'q':  case 'r':  case 's':  case 't':
		case 'u':  case 'v':  case 'w':  case 'x':
		case 'y':  case 'z':
		{
			matchRange('a','z');
			break;
		}
		case 'A':  case 'B':  case 'C':  case 'D':
		case 'E':  case 'F':  case 'G':  case 'H':
		case 'I':  case 'J':  case 'K':  case 'L':
		case 'M':  case 'N':  case 'O':  case 'P':
		case 'Q':  case 'R':  case 'S':  case 'T':
		case 'U':  case 'V':  case 'W':  case 'X':
		case 'Y':  case 'Z':
		{
			matchRange('A','Z');
			break;
		}
		case '_':
		{
			match('_');
			break;
		}
		case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
		case '\u00e4':  case '\u00f6':  case '\u00fc':
		{
			mUmlaut(false);
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		{
		_loop168:
		do {
			switch ( LA(1)) {
			case 'a':  case 'b':  case 'c':  case 'd':
			case 'e':  case 'f':  case 'g':  case 'h':
			case 'i':  case 'j':  case 'k':  case 'l':
			case 'm':  case 'n':  case 'o':  case 'p':
			case 'q':  case 'r':  case 's':  case 't':
			case 'u':  case 'v':  case 'w':  case 'x':
			case 'y':  case 'z':
			{
				matchRange('a','z');
				break;
			}
			case 'A':  case 'B':  case 'C':  case 'D':
			case 'E':  case 'F':  case 'G':  case 'H':
			case 'I':  case 'J':  case 'K':  case 'L':
			case 'M':  case 'N':  case 'O':  case 'P':
			case 'Q':  case 'R':  case 'S':  case 'T':
			case 'U':  case 'V':  case 'W':  case 'X':
			case 'Y':  case 'Z':
			{
				matchRange('A','Z');
				break;
			}
			case '_':
			{
				match('_');
				break;
			}
			case '.':
			{
				match('.');
				break;
			}
			case '-':
			{
				match('-');
				break;
			}
			case '\u00c4':  case '\u00d6':  case '\u00dc':  case '\u00df':
			case '\u00e4':  case '\u00f6':  case '\u00fc':
			{
				mUmlaut(false);
				break;
			}
			case '0':  case '1':  case '2':  case '3':
			case '4':  case '5':  case '6':  case '7':
			case '8':  case '9':
			{
				matchRange('0','9');
				break;
			}
			default:
			{
				break _loop168;
			}
			}
		} while (true);
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mSL_COMMENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = SL_COMMENT;
		int _saveIndex;
		
		match("#");
		{
		_loop176:
		do {
			if ((_tokenSet_1.member(LA(1)))) {
				{
				match(_tokenSet_1);
				}
			}
			else {
				break _loop176;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			_ttype = Token.SKIP;
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mDatumOderZahl(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = DatumOderZahl;
		int _saveIndex;
		
		boolean synPredMatched179 = false;
		if ((((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= '0' && LA(2) <= '9')) && (LA(3)=='.') && ((LA(4) >= '0' && LA(4) <= '9')) && ((LA(5) >= '0' && LA(5) <= '9')) && (LA(6)=='.'))) {
			int _m179 = mark();
			synPredMatched179 = true;
			inputState.guessing++;
			try {
				{
				mZiffer(false);
				mZiffer(false);
				match('.');
				mZiffer(false);
				mZiffer(false);
				match('.');
				mZiffer(false);
				mZiffer(false);
				mZiffer(false);
				mZiffer(false);
				}
			}
			catch (RecognitionException pe) {
				synPredMatched179 = false;
			}
			rewind(_m179);
inputState.guessing--;
		}
		if ( synPredMatched179 ) {
			mDatum(false);
			if ( inputState.guessing==0 ) {
				_ttype = Datum;
			}
		}
		else {
			boolean synPredMatched181 = false;
			if ((((LA(1) >= '0' && LA(1) <= '9')) && ((LA(2) >= '0' && LA(2) <= '9')) && (LA(3)==':'))) {
				int _m181 = mark();
				synPredMatched181 = true;
				inputState.guessing++;
				try {
					{
					mZiffer(false);
					mZiffer(false);
					match(':');
					mZiffer(false);
					mZiffer(false);
					match(':');
					mZiffer(false);
					mZiffer(false);
					match(',');
					mZiffer(false);
					mZiffer(false);
					mZiffer(false);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched181 = false;
				}
				rewind(_m181);
inputState.guessing--;
			}
			if ( synPredMatched181 ) {
				mZeit(false);
				if ( inputState.guessing==0 ) {
					_ttype = Zeit;
				}
			}
			else {
				boolean synPredMatched185 = false;
				if ((((LA(1) >= '0' && LA(1) <= '9')) && (true) && (true) && (true) && (true) && (true))) {
					int _m185 = mark();
					synPredMatched185 = true;
					inputState.guessing++;
					try {
						{
						{
						int _cnt184=0;
						_loop184:
						do {
							if (((LA(1) >= '0' && LA(1) <= '9'))) {
								mZiffer(false);
							}
							else {
								if ( _cnt184>=1 ) { break _loop184; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
							}
							
							_cnt184++;
						} while (true);
						}
						match('.');
						}
					}
					catch (RecognitionException pe) {
						synPredMatched185 = false;
					}
					rewind(_m185);
inputState.guessing--;
				}
				if ( synPredMatched185 ) {
					mKommaZahl(false);
					if ( inputState.guessing==0 ) {
						_ttype = KommaZahl;
					}
				}
				else {
					boolean synPredMatched190 = false;
					if ((((LA(1) >= '0' && LA(1) <= '9')) && (true) && (true) && (true) && (true) && (true))) {
						int _m190 = mark();
						synPredMatched190 = true;
						inputState.guessing++;
						try {
							{
							{
							_loop188:
							do {
								if (((LA(1) >= '0' && LA(1) <= '9'))) {
									mZiffer(false);
								}
								else {
									break _loop188;
								}
								
							} while (true);
							}
							{
							switch ( LA(1)) {
							case 'e':
							{
								match('e');
								break;
							}
							case 'E':
							{
								match('E');
								break;
							}
							default:
							{
								throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
							}
							}
							}
							}
						}
						catch (RecognitionException pe) {
							synPredMatched190 = false;
						}
						rewind(_m190);
inputState.guessing--;
					}
					if ( synPredMatched190 ) {
						mKommaZahl(false);
						if ( inputState.guessing==0 ) {
							_ttype = KommaZahl;
						}
					}
					else if (((LA(1) >= '0' && LA(1) <= '9')) && (true) && (true) && (true) && (true) && (true)) {
						mGanzZahl(false);
						if ( inputState.guessing==0 ) {
							_ttype = GanzZahl;
						}
					}
					else {
						throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
					}
					}}}
					if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
						_token = makeToken(_ttype);
						_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
					}
					_returnToken = _token;
				}
				
	protected final void mZiffer(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Ziffer;
		int _saveIndex;
		
		{
		matchRange('0','9');
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mDatum(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Datum;
		int _saveIndex;
		
		mZiffer(false);
		mZiffer(false);
		match('.');
		mZiffer(false);
		mZiffer(false);
		match('.');
		mZiffer(false);
		mZiffer(false);
		mZiffer(false);
		mZiffer(false);
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mZeit(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Zeit;
		int _saveIndex;
		
		mZiffer(false);
		mZiffer(false);
		match(':');
		mZiffer(false);
		mZiffer(false);
		match(':');
		mZiffer(false);
		mZiffer(false);
		match(',');
		mZiffer(false);
		mZiffer(false);
		mZiffer(false);
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mKommaZahl(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = KommaZahl;
		int _saveIndex;
		
		{
		int _cnt199=0;
		_loop199:
		do {
			if (((LA(1) >= '0' && LA(1) <= '9'))) {
				mZiffer(false);
			}
			else {
				if ( _cnt199>=1 ) { break _loop199; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			_cnt199++;
		} while (true);
		}
		{
		if ((LA(1)=='.')) {
			{
			match('.');
			}
			{
			int _cnt203=0;
			_loop203:
			do {
				if (((LA(1) >= '0' && LA(1) <= '9'))) {
					mZiffer(false);
				}
				else {
					if ( _cnt203>=1 ) { break _loop203; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				
				_cnt203++;
			} while (true);
			}
		}
		else {
		}
		
		}
		{
		if ((LA(1)=='E'||LA(1)=='e')) {
			{
			switch ( LA(1)) {
			case 'e':
			{
				match('e');
				break;
			}
			case 'E':
			{
				match('E');
				break;
			}
			default:
			{
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			{
			switch ( LA(1)) {
			case '-':
			{
				match('-');
				break;
			}
			case '0':  case '1':  case '2':  case '3':
			case '4':  case '5':  case '6':  case '7':
			case '8':  case '9':
			{
				break;
			}
			default:
			{
				throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
			}
			}
			}
			{
			int _cnt208=0;
			_loop208:
			do {
				if (((LA(1) >= '0' && LA(1) <= '9'))) {
					mZiffer(false);
				}
				else {
					if ( _cnt208>=1 ) { break _loop208; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
				}
				
				_cnt208++;
			} while (true);
			}
		}
		else {
		}
		
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mGanzZahl(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = GanzZahl;
		int _saveIndex;
		
		{
		int _cnt196=0;
		_loop196:
		do {
			if (((LA(1) >= '0' && LA(1) <= '9'))) {
				mZiffer(false);
			}
			else {
				if ( _cnt196>=1 ) { break _loop196; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			
			_cnt196++;
		} while (true);
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mNicht(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Nicht;
		int _saveIndex;
		
		match("nicht");
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mZeichenkette(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Zeichenkette;
		int _saveIndex;
		
		match('"');
		{
		_loop214:
		do {
			if ((LA(1)=='\\')) {
				mSteuerungszeichen(false);
			}
			else if ((_tokenSet_2.member(LA(1)))) {
				{
				match(_tokenSet_2);
				}
			}
			else {
				break _loop214;
			}
			
		} while (true);
		}
		match('"');
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	protected final void mSteuerungszeichen(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = Steuerungszeichen;
		int _saveIndex;
		
		match('\\');
		{
		switch ( LA(1)) {
		case 'n':
		{
			match('n');
			if ( inputState.guessing==0 ) {
				text.setLength(_begin); text.append("\n");
			}
			break;
		}
		case '"':
		{
			match('"');
			if ( inputState.guessing==0 ) {
				text.setLength(_begin); text.append("\"");
			}
			break;
		}
		case '\\':
		{
			match('\\');
			if ( inputState.guessing==0 ) {
				text.setLength(_begin); text.append("\\");
			}
			break;
		}
		default:
		{
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		}
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mWS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = WS;
		int _saveIndex;
		
		{
		int _cnt222=0;
		_loop222:
		do {
			switch ( LA(1)) {
			case ' ':
			{
				match(' ');
				break;
			}
			case '\t':
			{
				match('\t');
				break;
			}
			case '\\':
			{
				match('\\');
				{
				_loop220:
				do {
					switch ( LA(1)) {
					case ' ':
					{
						match(' ');
						break;
					}
					case '\t':
					{
						match('\t');
						break;
					}
					default:
					{
						break _loop220;
					}
					}
				} while (true);
				}
				{
				switch ( LA(1)) {
				case '#':
				{
					mSL_COMMENT(false);
					break;
				}
				case '\n':  case '\r':
				{
					break;
				}
				default:
				{
					throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
				}
				}
				}
				mZeilenEnde(false);
				break;
			}
			default:
			{
				if ( _cnt222>=1 ) { break _loop222; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
			}
			}
			_cnt222++;
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			_ttype = Token.SKIP;
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	public final void mZeilenEnde(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
		int _ttype; Token _token=null; int _begin=text.length();
		_ttype = ZeilenEnde;
		int _saveIndex;
		
		{
		if ((LA(1)=='\r') && (LA(2)=='\n')) {
			match("\r\n");
		}
		else if ((LA(1)=='\n')) {
			match('\n');
		}
		else if ((LA(1)=='\r') && (true)) {
			match('\r');
		}
		else {
			throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
		}
		
		}
		if ( inputState.guessing==0 ) {
			newline(); _ttype = Token.SKIP;
		}
		if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
			_token = makeToken(_ttype);
			_token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
		}
		_returnToken = _token;
	}
	
	
	private static final long[] mk_tokenSet_0() {
		long[] data = new long[8];
		data[1]=576460745995190270L;
		data[3]=1170935974255919120L;
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = new long[8];
		data[0]=-9224L;
		for (int i = 1; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = new long[8];
		data[0]=-17179878408L;
		data[1]=-268435457L;
		for (int i = 2; i<=3; i++) { data[i]=-1L; }
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	
	}
